routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\LevelController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->middleware('auth');

Route::resource('category', CategoryController::class)->middleware('auth');
Route::resource('course', CourseController::class)->middleware('auth');
Route::resource('level', LevelController::class)->middleware('auth');
Route::resource('user', UserController::class)->middleware('auth');


Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home')->middleware('auth');

app/Models/Course.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Course extends Model
{
    use HasFactory;

    protected $guarded = [];

    public function statusOptions(){
        return [
            1 => 'Active',
            0 => 'Inactive',
            2 => 'In-Progress'
        ];
    }

    public function category(){
        return $this->belongsTo(Category::class);
    }

    public function level(){
        return $this->belongsTo(Level::class);
    }

    public function user(){
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/CourseController.php
<?php

namespace App\Http\Controllers;

use App\Models\Course;
use App\Models\Category;
use App\Models\Level;
use App\Models\User;
use Illuminate\Http\Request;

class CourseController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $courses = Course::all();
        return view('course.index', compact('courses'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Category::all();
        $levels = Level::all();
        $users = User::all();
        $course = new Course();
        return view('course.create', compact('course','categories', 'levels', 'users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        if(!isset($request['free'])){
            $request['free'] = 0;
        }
        if(!isset($request['soon'])){
            $request['soon'] = 0;
        }
        //dd($this->validateRequest());
        $course = Course::create($this->validateRequest());
        $this->storeImage($course);
        $this->storeVideo($course);

        return redirect('course');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Course  $course
     * @return \Illuminate\Http\Response
     */
    public function show(Course $course)
    {
        return view('course.show',compact('course'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Course  $course
     * @return \Illuminate\Http\Response
     */
    public function edit(Course $course)
    {
        $categories = Category::all();
        $levels = Level::all();
        $users = User::all();
        return view('course.edit', compact('course', 'categories', 'levels', 'users'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Course  $course
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Course $course)
    {
        //$request['category_id'] = 1;
        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        if(!isset($request['free'])){
            $request['free'] = 0;
        }
        if(!isset($request['soon'])){
            $request['soon'] = 0;
        }
        $course->update($this->validateRequest());
        $this->storeImage($course);
        $this->storeVideo($course);
        //dd($request);
        return redirect('course/'.$course->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Course  $course
     * @return \Illuminate\Http\Response
     */
    public function destroy(Course $course)
    {
        $course->delete();
        return redirect('course');
    }


    private function uploadImage($folder, $image){
        $image->store('/', $folder);
        $filename = $image->hashName();
        return  $filename;
    }

    private function validateRequest()
    {
        return tap( \request()->validate([
            'name' => 'required',
            'category_id' => 'integer',
            'level_id' => 'integer',
            'user_id' => 'integer',
            'slog' => 'required',
            'free' => 'integer',
            'soon' => 'integer',
            'price' => 'integer',
            'certificate_price' => 'integer',
            'course_description' => 'nullable',
            'what_to_learn' => 'nullable',
            //'category_id' => 'required',
            'status' => 'integer']), function(){
                if(\request()->hasFile('image')){
                    \request()->validate([
                        'image'=>'mimes:jpeg,jpg,png,gif|file|image|max:5000'
                    ]);
                }
            if(\request()->hasFile('video')){
                \request()->validate([
                    'video'=>'mimes:mp4,amv,vlc|file|max:55000'
                ]);
            }
            });
    }

    private function storeImage($course){
        if(\request()->has('image')){
            $course->update([
                'image' =>\request()->image->store('uploads', 'public'),
            ]);
        }
    }

    private function storeVideo($course){
        if(\request()->has('video')){
            $course->update([
                'video' =>\request()->video->store('uploads', 'public'),
            ]);
        }
    }
}

resources/views/course/create.blade.php
@extends('layouts.app')

@section('title', 'Add New Course')


@section('content')

    <div class="row">
        <div class="col-12">
            <form action="{{route('course.store')}}" method="POST" class="" enctype="multipart/form-data">

                @include('course.form')

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/course/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Details for '. $course->name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>Edit Details for {{ $course->name }}</h1>
        </div>
    </div>

    <div class="row">
        <div class="col-12">
            <form action=" {{route('course.update', ['course' => $course])}}" method="POST" class="" enctype="multipart/form-data">
                @method('PATCH')
                @include('course.form')
                <button type="submit" class="btn btn-primary pt-2">Save Category</button>

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/course/form.blade.php
@csrf
<div class="col-md-12">
    <div class="card">
        <div class="card-header">
            <h4 class="card-title">@yield('title')</h4>
        </div>
        <div class="card-content">
            <div class="card-body">
                <form class="form form-horizontal">
                    <div class="form-body">
                        <div class="row">
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Name</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="name" value="{{ old('name') ?? $course->name }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('name') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Category</span>
                                    </div>
                                    <div class="col-md-8">
                                        <select class="form-control" id="basicSelect" name="category_id">
                                            @foreach($categories as $category)
                                                <option value="{{ $category->id }}" {{ $category->id == $course->category_id? 'selected' : '' }}>{{ $category->en_name }}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                    <div>{{ $errors->first('category_id') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Level</span>
                                    </div>
                                    <div class="col-md-8">
                                        <select class="form-control" id="basicSelect" name="level_id">
                                            @foreach($levels as $one)
                                                <option value="{{ $one->id }}" {{ $one->id == $course->level_id? 'selected' : '' }}>{{ $one->en_name }}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                    <div>{{ $errors->first('level_id') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Level</span>
                                    </div>
                                    <div class="col-md-8">
                                        <select class="form-control" id="basicSelect" name="user_id">
                                            @foreach($users as $one)
                                                <option value="{{ $one->id }}" {{ $one->id == $course->level_id? 'selected' : '' }}>{{ $one->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                    <div>{{ $errors->first('user_id') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Slog</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="slog" value="{{ old('slog') ?? $course->slog }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('slog') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Price</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="number" name="price" value="{{ old('price') ?? $course->price }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('price') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Certificate Price</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="number" name="certificate_price" value="{{ old('certificate_price') ?? $course->certificate_price }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('certificate_price') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Course Description</span>
                                    </div>
                                    <div class="col-md-8">
                                        <textarea name="course_description"  class="form-control">{{ old('course_description') ?? $course->course_description }}</textarea>
                                    </div>
                                    <div>{{ $errors->first('course_description') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>What to Learn</span>
                                    </div>
                                    <div class="col-md-8">
                                        <textarea name="what_to_lear" class="form-control">{{ old('what_to_lear') ?? $course->what_to_lear }}</textarea>
                                    </div>
                                    <div>{{ $errors->first('what_to_lear') }}</div>
                                </div>
                            </div>


                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Image</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="file" name="image" class="form-control">
                                        <?php if($course->image){ ?>
                                            <img class="img-lg" src="{{ asset('storage/'.$course->image) }}" >
                                        <?php } ?>
                                    </div>
                                    <div>{{ $errors->first('image') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Video</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="file" name="video" class="form-control">
                                        <?php if($course->video){ ?>
                                        <video class="img-lg" src="{{ asset('storage/'.$course->video) }}" ></video>
                                        <?php } ?>
                                    </div>
                                    <div>{{ $errors->first('video') }}</div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Free</span>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-switch custom-switch-success mr-2 mb-1">
                                            <p class="mb-0">Free</p>
                                            <input type="checkbox" value="1"  <?= $course->free ? 'checked': ''; ?> class="custom-control-input" id="course_free" name="free">
                                            <label class="custom-control-label" for="course_free"></label>
                                        </div>
                                        <div>{{ $errors->first('free') }}</div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Soon</span>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-switch custom-switch-success mr-2 mb-1">
                                            <p class="mb-0">Soon</p>
                                            <input type="checkbox" value="1" <?= $course->soon ? 'checked': ''; ?> class="custom-control-input" id="course_soon" name="soon">
                                            <label class="custom-control-label" for="course_soon"></label>
                                        </div>
                                        <div>{{ $errors->first('soon') }}</div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Status</span>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-switch custom-switch-success mr-2 mb-1">
                                            <p class="mb-0">Active</p>
                                            <input type="checkbox" value="1" <?= $course->status ? 'checked': ''; ?> class="custom-control-input" id="course_status" name="status">
                                            <label class="custom-control-label" for="course_status"></label>
                                        </div>
                                        <div>{{ $errors->first('status') }}</div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-8 offset-md-4">
                                <button type="submit" class="btn btn-primary mr-1 mb-1 waves-effect waves-light">Submit</button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

resources/views/course/index.blade.php
<?php
?>
@extends('layouts.app')

@section('title', 'Course List')


@section('content')
    <section id="grid-options" class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">@yield('title')</h4>
                    <a class="btn btn-success btn-sm pull-right" href="{{route('course.create')}}">Create</a>
                </div>
                <div class="card-content">
                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped">
                                <thead>
                                <tr>
                                    <th></th>
                                    <th class="text-center">
                                       Category
                                    </th>
                                    <th class="text-center">
                                       Level
                                    </th>
                                    <th class="text-center">
                                       Teacher
                                    </th>
                                    <th class="text-center">
                                       Name
                                    </th>
                                    <th class="text-center">
                                        Status
                                    </th>
                                    <th class="text-center">
                                        Actions
                                    </th>
                                </tr>
                                </thead>
                                <tbody style="text-align: center">
                                @foreach($courses as $course)
                                    <tr>
                                        <td> {{ $course->id }}</td>
                                        <td>{{ $course->category->en_name }}</td>
                                        <td>{{ $course->level->en_name }}</td>
                                        <td>{{ $course->user->name }}</td>
                                        <td><a href="/course/{{ $course->id }}">{{ $course->name }}</a></td>
                                        <td>{{ $course->statusOptions()[$course->status] }}</td>
                                        <td>
                                            <a href="{{route('course.edit', ['course' => $course])}}"><i class="fa fa-edit"></i></a>
                                            <a href="{{route('course.show', ['course' => $course])}}"><i class="fa fa-eye"></i></a>
                                            <form action="{{route('course.destroy', ['course' => $course])}}" method="POST">
                                                @method('DELETE')
                                                @csrf
                                                <button class="btn btn danger" type="submit"><i class="fa fa-trash"></i></button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection()

resources/views/course/show.blade.php
@extends('layouts.app')

@section('title', 'Details for ' . $course->name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>{{'Details for ' . $course->name}}</h1>
            <p style="float: right;
padding: 0;
margin: 0;">
                <a href="/course/{{ $course->id }}/edit">Edit</a>
            <form action="/course/{{ $course->id }}" method="POST" style="width: 7%;
float: right;
margin-top: -10px;">
                @method('DELETE')
                @csrf
                <button class="btn btn danger" type="submit">Delete</button>
            </form>
            </p>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <table class="table table-bordered table-striped">
                <tr>
                    <th>Id</th>
                    <td>{{$course->id}}</td>
                </tr>
                <tr>
                    <th>Name</th>
                    <td>{{$course->name}}</td>
                </tr>
                <tr>
                    <th>Slog</th>
                    <td>{{$course->slog}}</td>
                </tr>
                <tr>
                    <th>Category</th>
                    <td>{{$course->category->en_name}}</td>
                </tr>
                <tr>
                    <th>Level</th>
                    <td>{{$course->level->en_name}}</td>
                </tr>
                <tr>
                    <th>Teacher</th>
                    <td>{{$course->user->name}}</td>
                </tr>
                <tr>
                    <th>Level</th>
                    <td>{{$course->level_id}}</td>
                </tr>
                <tr>
                    <th>Price</th>
                    <td>{{$course->price}}</td>
                </tr>
                <tr>
                    <th>Certificate Price</th>
                    <td>{{$course->certificate_price}}</td>
                </tr>
                <tr>
                    <th>Course Description</th>
                    <td>{{$course->course_description}}</td>
                </tr>
                <tr>
                    <th>What to Learn</th>
                    <td>{{$course->what_to_lear}}</td>
                </tr>
                <tr>
                    <th>Image</th>
                    <td>
                        <?php if($course->image){ ?>
                        <img class="img-lg" src="{{ asset('storage/'.$course->image) }}" >
                        <?php } ?>
                    </td>
                </tr>
                <tr>
                    <th>Video</th>
                    <td>
                        <?php if($course->video){ ?>
                        <video src="{{ asset('storage/'.$course->video) }}" ></video>
                        <?php } ?>
                    </td>
                </tr>
                <tr>
                    <th>Free</th>
                    <td>{{$course->free ? 'Yes' : 'No'}}</td>
                </tr>
                <tr>
                    <th>Soon</th>
                    <td>{{$course->soon ? 'Yes' : 'No'}}</td>
                </tr>
                <tr>
                    <th>Status</th>
                    <td>{{$course->status ? 'Active' : 'Not Active'}}</td>
                </tr>
            </table>
        </div>
    </div>
@endsection()